#include <iostream>
#include "funcRealization.h"

int main() {
    bool flag = 1;
    // проверим все на векторе
    std::vector<int> vec;
    std::ifstream file;
    int func_choice;
    while (flag){
        std::cout << "Select a function" << std::endl
                  << "1 - create data by file stream" << std::endl
                  << "2 - create data by using generate()"<< std::endl
                  << "3 - load data by file stream" << std::endl
                  << "4 - load data by algoritm copy()" << std::endl
                  << "5 - modify adding to elements of massive half of last negative element of massive" << std::endl
                  << "6 - modify version, which adds to the end sum of numbers and average of all elements"<< std::endl
                  << "7 - modify version, which gets arguments-iterators" << std::endl
                  << "8 - modify version, which uses transorm()" << std::endl
                  << "9 - output result, " << std::endl
                  << "10 - modify version, which uses transorm()" << std::endl;
        std::cin >> func_choice;
        switch (func_choice){
            case 1:
                create_data_using_file_stream();
                file.open("file.txt");
                if (!file.is_open())
                    std::cout << "Error";
                else{
                    std::cout << "Output file" << std::endl;
                    std::for_each(std::istream_iterator<int>(file), std::istream_iterator<int>(), [](auto& val) {std::cout << val << " "; });
                }
                std::cout << std::endl;
                file.close();
                break;
            case 2:
                create_data_using_generate();
                file.open("file.txt");
                if (!file.is_open())
                    std::cout << "Error";
                else{
                    std::cout << "Output file by using generate:" << std::endl;
                    std::for_each(std::istream_iterator<int>(file), std::istream_iterator<int>(), [](auto& val) {std::cout << val << " "; });
                }
                std::cout << std::endl;
                file.close();
                break;
            case 3:
                load_data_using_file_stream(vec);
                std::cout << "Output vector after loading data using filestreams:" << std::endl;
                std::for_each(vec.begin(), vec.end(), [](auto val) {std::cout << val << " "; });
                std::cout << std::endl;
                break;
            case 4:
                loaddata_using_copy_and_iterator(vec);
                std::cout << "Output vector after loading data using filestreams:" << std::endl;
                std::for_each(vec.begin(), vec.end(), [](auto val) {std::cout << val << " "; });
                std::cout << std::endl;
                break;
            case 5:
                modify(vec);
                std::cout << "Output vector after loading data using filestreams:" << std::endl;
                std::for_each(vec.begin(), vec.end(), [](auto val) {std::cout << val << " "; });
                std::cout << std::endl;
                break;
            case 6:
                modify_container_getter(vec);
                std::cout << "Output vector after loading data using filestreams:" << std::endl;
                std::for_each(vec.begin(), vec.end(), [](auto val) {std::cout << val << " "; });
                std::cout << std::endl;
                break;
            case 7:
                modify_args_iters(vec.begin(), vec.end());
                std::cout << "Output vector after loading data using filestreams:" << std::endl;
                std::for_each(vec.begin(), vec.end(), [](auto val) {std::cout << val << " "; });
                std::cout << std::endl;
                break;
            case 8:
                modify_transform(file);
                std::cout << "Output vector after loading data using filestreams:" << std::endl;
                std::for_each(vec.begin(), vec.end(), [](auto val) {std::cout << val << " "; });
                std::cout << std::endl;
                break;
            case 9:
                output_by_file_stream(vec);
                file.open("file.txt");
                if (!file.is_open())
                    std::cout << "Error";
                else{
                    std::cout << "Output file" << std::endl;
                    std::for_each(std::istream_iterator<int>(file), std::istream_iterator<int>(), [](auto& val) //!!! val не изменяется. Где const?
                    {std::cout << val << " "; });
                }
                std::cout << std::endl;
                file.close();
                break;
            case 10:
                output_using_copy(vec);
                file.open("file.txt");
                if (!file.is_open())
                    std::cout << "Error";
                else{
                    std::cout << "Output file" << std::endl;
                    std::for_each(std::istream_iterator<int>(file), std::istream_iterator<int>(), [](auto& val)//!!! val не изменяется. Где const?
                    {std::cout << val << " "; });
                }
                std::cout << std::endl;
                file.close();
                break;
            default:
                flag = 0;
                break;
        }
    }
    file.close();
    return 0;
}
